package com.jxdinfo.hussar.core.util;

import com.jxdinfo.hussar.core.bouncycastle.asn1.DEREncodableVector;
import com.jxdinfo.hussar.core.bouncycastle.jce.provider.BouncyCastleProvider;
import com.jxdinfo.hussar.core.exception.HussarException;
import com.jxdinfo.hussar.core.util.EncryptUtil;
import java.security.Key;
import java.security.SecureRandom;
import java.security.Security;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;
import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

public class HussarAES {

   static int F = 0;
   final String j = "AES/CBC/PKCS5Padding";
   private Key G;
   private Cipher C;
   final String e = "AES";
   private final int[] char;


   public HussarAES() {
      int[] var10001 = new int[60];
      boolean var10003 = true;
      ((Object[])true)[0] = (boolean)462357;
      ((Object[])true)[1] = (boolean)472066609;
      ((Object[])true)[2] = (boolean)943670861;
      ((Object[])true)[3] = (boolean)1415275113;
      ((Object[])true)[4] = (boolean)1886879365;
      ((Object[])true)[5] = (boolean)-1936483679;
      ((Object[])true)[6] = (boolean)-1464879427;
      ((Object[])true)[7] = (boolean)-993275175;
      ((Object[])true)[8] = (boolean)-521670923;
      ((Object[])true)[9] = (boolean)-66909679;
      ((Object[])true)[10] = (boolean)404694573;
      ((Object[])true)[11] = (boolean)876298825;
      ((Object[])true)[12] = (boolean)808926789;
      ((Object[])true)[13] = (boolean)1280531041;
      ((Object[])true)[14] = (boolean)1752135293;
      ((Object[])true)[15] = (boolean)-2071227751;
      ((Object[])true)[16] = (boolean)1347903077;
      ((Object[])true)[17] = (boolean)1819507329;
      ((Object[])true)[18] = (boolean)-2003855715;
      ((Object[])true)[19] = (boolean)-1532251463;
      ((Object[])true)[20] = (boolean)-1060647211;
      ((Object[])true)[21] = (boolean)-589042959;
      ((Object[])true)[22] = (boolean)-117504499;
      ((Object[])true)[23] = (boolean)337322537;
      ((Object[])true)[24] = (boolean)808926789;
      ((Object[])true)[25] = (boolean)1280531041;
      ((Object[])true)[26] = (boolean)1752135293;
      ((Object[])true)[27] = (boolean)-2071227751;
      ((Object[])true)[28] = (boolean)-1599623499;
      ((Object[])true)[29] = (boolean)-1128019247;
      ((Object[])true)[30] = (boolean)-656414995;
      ((Object[])true)[31] = (boolean)-184876535;
      ((Object[])true)[32] = (boolean)269950501;
      ((Object[])true)[33] = (boolean)741554753;
      ((Object[])true)[34] = (boolean)1213159005;
      ((Object[])true)[35] = (boolean)1684763257;
      ((Object[])true)[36] = (boolean)-66909679;
      ((Object[])true)[37] = (boolean)404694573;
      ((Object[])true)[38] = (boolean)876298825;
      ((Object[])true)[39] = (boolean)1347903077;
      ((Object[])true)[40] = (boolean)1819507329;
      ((Object[])true)[41] = (boolean)-2003855715;
      ((Object[])true)[42] = (boolean)943670861;
      ((Object[])true)[43] = (boolean)1415275113;
      ((Object[])true)[44] = (boolean)1886879365;
      ((Object[])true)[45] = (boolean)-1936483679;
      ((Object[])true)[46] = (boolean)-589042959;
      ((Object[])true)[47] = (boolean)-117504499;
      ((Object[])true)[48] = (boolean)337322537;
      ((Object[])true)[49] = (boolean)808926789;
      ((Object[])true)[50] = (boolean)1280531041;
      ((Object[])true)[51] = (boolean)-1532251463;
      ((Object[])true)[52] = (boolean)-1060647211;
      ((Object[])true)[53] = (boolean)-589042959;
      ((Object[])true)[54] = (boolean)-117504499;
      ((Object[])true)[55] = (boolean)337322537;
      ((Object[])true)[56] = (boolean)808926789;
      ((Object[])true)[57] = (boolean)1280531041;
      ((Object[])true)[58] = (boolean)1752135293;
      ((Object[])true)[59] = (boolean)-2071227751;
      var10001.char = (int[])true;
   }

   public static void main(String[] a) throws Exception {
      String var1 = DEREncodableVector.const("洩讫/35勑宧");
      String var2 = HussarException.const("hjdai;dl");
      System.out.println(Integer.parseInt(var2, 16));
      HussarAES var5;
      HussarAES var10000 = var5 = new HussarAES();
      Date var10003 = new Date;
      var5.<init>();
      String var3 = var10003.getKey(var5);
      System.out.println(var3);
      byte[] var4 = var10000.encrypt(var1.getBytes("UTF-8"), var3.getBytes("UTF-8"));
      System.out.println((new StringBuilder()).insert(0, DEREncodableVector.const("勆宷ｻ")).append(new String(EncryptUtil.Base64Encode(var4))).toString());
      var4 = var5.decrypt(var4, var3.getBytes("UTF-8"));
      System.out.println((new StringBuilder()).insert(0, HussarException.const("覽定ｃ")).append(new String(var4, "UTF-8")).toString());
      var1 = new String(var5.decrypt(EncryptUtil.Base64Decode(DEREncodableVector.const("24HS\u0018+\u000b\u0016\u001e;9L\u000b\u0004\t\u0015\u0002r6\u0007\u00120\u000e);\"IT)\b\f\u0002\u001d\u0005\u0016\u0007iL1-SL^1\u001b:7\u0019\u000e\t\u0017\u001b\u000brx*\u0017;F\t9-G;").getBytes("UTF-8")), HussarException.const("gnk4ble`").getBytes("UTF-8")));
      System.err.println(var1);
   }

   public String getKey(Date a1) {
      Calendar var2 = Calendar.getInstance();
      var2.setTime(a1);
      int a2 = var2.get(12);
      return Integer.toHexString(a.char[a2]);
   }

   public byte[] decrypt(byte[] a1, byte[] a2) throws Exception {
      Object var3 = null;
      a.init(a2);
      byte[] var10000 = new byte[F];
      Object a3 = true;
      byte[] var10001 = new byte[a1.length - 16];
      Object var4 = true;
      System.arraycopy(a1, 0, a3, 0, 16);
      System.arraycopy(a1, F, var4, 0, a1.length - F);

      try {
         a.C.init(2, a.G, new IvParameterSpec((byte[])a3));
         byte[] var7 = a.C.doFinal((byte[])var4);
         return var7;
      } catch (Exception var5) {
         var5.printStackTrace();
         return (byte[])var3;
      }
   }

   public void init(byte[] a1) throws Exception {
      Security.addProvider(new BouncyCastleProvider());
      a.C = Cipher.getInstance("AES/CBC/PKCS5Padding", "BC");
      F = a.C.getBlockSize();
      byte[] var10000;
      if(a1.length % F != 0) {
         var10000 = new byte[(a1.length / F + (a1.length % F != 0?1:0)) * F];
         Object var3 = true;
         Arrays.fill((byte[])var3, (byte)0);
         System.arraycopy(a1, 0, var3, 0, a1.length);
         a1 = (byte[])var3;
      }

      if(a1.length > F) {
         var10000 = new byte[F];
         Object var2 = true;
         Arrays.fill((byte[])var2, (byte)0);
         System.arraycopy(a1, 0, var2, 0, F);
         a1 = (byte[])var2;
      }

      a.G = new SecretKeySpec(a1, "AES");
   }

   public boolean checkKey(String a1) {
      int[] var2 = a.char;
      Arrays.sort(var2);
      return Arrays.binarySearch(var2, Integer.parseInt(a1)) >= 0;
   }

   public byte[] encrypt(byte[] a1, byte[] a2) throws Exception {
      byte[] var3 = null;
      a.init(a2);
      byte[] var10000 = new byte[F];
      Object a4 = true;
      (new SecureRandom()).nextBytes((byte[])a4);

      try {
         a.C.init(1, a.G, new IvParameterSpec((byte[])a4));
         var3 = a.C.doFinal(a1);
      } catch (Exception var4) {
         var4.printStackTrace();
      }

      byte[] var10001 = new byte[F + var3.length];
      Object a3 = true;
      System.arraycopy(a4, 0, a3, 0, F);
      System.arraycopy(var3, 0, a3, F, var3.length);
      return (byte[])a3;
   }
}
